<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 11:41
 */

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Services\ExportacaoExcelService;
use HCM\Util\FPA;
use Zeedhi\Framework\HTTP\Kernel;

class ParcnegocioService {
    
    protected $entityManager;
    /** @var Environment */
    protected $environment;
    protected $hcmParameters;

    protected $parcnegocio;

    public function __construct(EntityManager $entityManager, Environment $environment, HCMParameters $hcmParameters, ExportacaoExcelService $exportacaoExcelService, Kernel $httpKernel, VinculoServices $vinculoServices) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->hcmParameters   = $hcmParameters;
        $this->parcnegocio = Repositories::PARCNEGOCIO;
        $this->relacionaparc = Repositories::RELACIONAPARC;
        $this->enderecoParc = Repositories::ENDERECOPARC;
        $this->contCorrParc = Repositories::CONTCORRPARC;
        $this->exportacaoExcelService = $exportacaoExcelService;
        $this->httpKernel = $httpKernel;
        $this->vinculoServices = $vinculoServices;
    }

    public function novo($nrorg, $nmprincipalparc, $nmsecundariparc, $cdtipoparceiro, $idpessoafisica, $idinstituicao,
                         $cdtipoinscricao, $nrinscricaoparc, $dtnascifundparc)
    {
        $idativo = 'S';
        $parceiro = new $this->parcnegocio;
        $parceiro->setNrorg($nrorg);
        $parceiro->setIdativo($idativo);
        $parceiro->setNmprincipalparc($nmprincipalparc);
        $parceiro->setNmsecundariparc($nmsecundariparc);
        $parceiro->setCdtipoparcprincipal($cdtipoparceiro);
        $parceiro->setIdpessoafisica($idpessoafisica);
        $parceiro->setIdinstituicao($idinstituicao);
        $parceiro->setCdtipoinscricao($cdtipoinscricao);
        $parceiro->setNrinscricaoparc($nrinscricaoparc);
        $parceiro->setDtnascifundparc($dtnascifundparc);

        $parceiro->setDtinclusao(DateUtil::getDataAtual());
        $parceiro->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $parceiro->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $parceiro->setDtultatu(DateUtil::getDataAtual());
        $parceiro->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $parceiro->setCdoperultatu($this->hcmParameters->getCdoperador());

        $parceiro->setNrparcnegocio(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'PARCNEGOCIO', 1, 12, true));

        $this->entityManager->persist($parceiro);
        $this->entityManager->flush($parceiro); 
        //\ParceriaEntity::incluiParceria($this->nrorg, $this->parceiro->getNrparcnegocio(), $cdtipoparceiro, $idativo);

        return $parceiro;
    }

    public function novoRelacionaparc($nrorg, $nrtiporelaciona, $nrparcnegocio, $dtfimrelacionamento, $nrparcnegrelac)
    {
        $relacionaparc = new $this->relacionaparc;

        $relacionaparc->setNrorg($nrorg);
        $relacionaparc->setDtinclusao(DateUtil::getDataAtual());
        $relacionaparc->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $relacionaparc->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $relacionaparc->setDtultatu(DateUtil::getDataAtual());
        $relacionaparc->setCdoperultatu($this->hcmParameters->getCdoperador());
        $relacionaparc->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $relacionaparc->setNrparcnegocio($nrparcnegocio);
        $relacionaparc->setNrtiporelaciona($nrtiporelaciona);
        $relacionaparc->setNrparcnegrelac($nrparcnegrelac);
        //$relacionaparc->setDtfimrelacionamento($dtfimrelacionamento);
        $relacionaparc->setIdativo('S');
        $relacionaparc->setNrrelacionaparc(\HCM\Util\NovoCodigo::geraCodigo($nrorg, 'RELACIONAPARC', 1, 10, true));

        $this->entityManager->persist($relacionaparc);
        $this->entityManager->flush($relacionaparc);
        return $relacionaparc;
    }

    public function getParcnegocioVinculos($parameters, $conditions) {
        
        $OcupacaoPorComite = '';
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $cdtipoparcprincipal = $parameters["P_CDTIPOPARCPRINCIPAL"];
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        
        //FitrarPorTipoComiteOcupacao
        if(isset($parameters["TIPOCOMITEOCUPACAO"])){
        $OcupacaoPorComite = 'INNER JOIN GPE_TIPOCOMITEOCUP TPO 
                    ON TPO.NROCUPACAOM = OCM.NROCUPACAOM AND TPO.NRORG = OCM.NRORG';
        }
        
        $query = $this->entityManager->getConnection()->prepare("
            SELECT * FROM (   
                SELECT
                    PARC.*,OCM.NROCUPACAOM, OCH.NMOCUPACAOH
                    FROM PARCNEGOCIO PARC
                    JOIN GPE_PESSOA PE
                        ON PE.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        AND PE.NRORG = PARC.NRORG
                    JOIN GPE_VINCULOM VCM 
                        ON PE.NRPESSOA = VCM.NRPESSOA
                        AND PE.NRORG = VCM.NRORG
                        AND VCM.DTRESCISAOVINC IS NULL
                    JOIN GPE_VINCULOH VCH 
                        ON VCM.NRVINCULOM = VCH.NRVINCULOM
                        AND VCM.NRORG = VCH.NRORG
                        AND VCH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VCH1
                            WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                AND VCH1.NRVINCULOM = VCH.NRVINCULOM
                                AND VCH1.NRORG = VCH.NRORG)
                    LEFT JOIN GPE_OCUPACAOM OCM 
                        ON OCM.NROCUPACAOM = NVL(VCH.NRCARGO, VCH.NRFUNCAO) 
                        AND OCM.NRORG = VCH.NRORG
                    LEFT JOIN GPE_OCUPACAOH OCH 
                        ON OCM.NROCUPACAOM = OCH.NROCUPACAOM
                        AND OCM.NRORG = OCH.NRORG
                        AND OCH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                            WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                AND NROCUPACAOM = OCH.NROCUPACAOM
                                AND NRORG = OCH.NRORG)
                    $OcupacaoPorComite            
                WHERE PARC.NRORG   = :P_NRORG
                    AND PARC.IDATIVO = 'S'
                    AND PARC.CDTIPOPARCPRINCIPAL IN ($cdtipoparcprincipal)
                    AND (:P_NMPRINCIPALPARC IS NULL OR UPPER(PARC.NMPRINCIPALPARC) LIKE UPPER(:P_NMPRINCIPALPARC))
                    AND (ROWNUM <= :P_ITEMSPERPAGE OR :P_ITEMSPERPAGE IS NULL)
                    ORDER BY NMPRINCIPALPARC)
            WHERE 1 = 1
              $conditions
        ");

        $query->execute(
            array(
                "P_NRORG"               => $nrorg,
                "P_NMPRINCIPALPARC"     => (isset($parameters["NMPRINCIPALPARC"])) ? $parameters["NMPRINCIPALPARC"] : null,
                "P_ITEMSPERPAGE"        => (isset($parameters["P_ITEMSPERPAGE"])) ? $parameters["P_ITEMSPERPAGE"] : null,
                "P_DTMESCOMPETENC" => $dtmescompetenc
            )
        );

        $tipoprocesso = $query->fetchAll();
        return $tipoprocesso;

    }
    
    public function cadAutoFormaComu($rows) {
        foreach ($rows as $row) {
            $this->novaFormacomu($row['NRPARCNEGOCIO'], $row['CDFORMACOMU'], $row['CDPREFIXCOMUPARC'], $row['CDCOMUNICAPARC'], null, null);
        }    
    }
    
    public function novaFormacomu($nrparcnegocio, $cdformacomu, $cdprefixcomuparc, $cdcomunicaparc, $cdcomplecomuparc, $nrenderecoparc) {
        $comunicaParc = Repositories::COMUNICAPARC;
        
        $obj = new $comunicaParc;
        $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtinclusao(DateUtil::getDataAtual());
        $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtultatu(DateUtil::getDataAtual());
        $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
        $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $obj->setIdativo('S');
        $obj->setNrparcnegocio($nrparcnegocio);
        $obj->setCdformacomu($cdformacomu);
        $obj->setCdprefixcomuparc($cdprefixcomuparc);
        $obj->setCdcomunicaparc($cdcomunicaparc);
        $obj->setCdcomplecomuparc($cdcomplecomuparc);
        $obj->setNrenderecoparc($nrenderecoparc);
        $nrcomunicaparc = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'COMUNICAPARC', 1, 12, true);
        $obj->setNrcomunicaparc($nrcomunicaparc);
        
        $this->entityManager->persist($obj);
        $this->entityManager->flush($obj);
    }
    
    public function novoEndereco($nrparcnegocio, $cdpais, $sgestado, $cdmunicipio, $cdlogradouro, $nmbairroendereco,
                         $cdtipoendereco, $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
                         $dsreferenciaende)
    {
        $endereco = new $this->enderecoParc;

        $endereco->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $endereco->setDtinclusao(DateUtil::getDataAtual());
        $endereco->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $endereco->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $endereco->setDtultatu(DateUtil::getDataAtual());
        $endereco->setCdoperultatu($this->hcmParameters->getCdoperador());
        $endereco->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $endereco->setNrparcnegocio($nrparcnegocio);
        $endereco->setCdpais($cdpais);
        $endereco->setIdativo('S');
        $endereco->setSgestado($sgestado);
        $endereco->setCdmunicipio($cdmunicipio);
        $endereco->setCdlogradouro($cdlogradouro);
        $endereco->setNmbairroendereco($nmbairroendereco);
        $endereco->setCdtipoendereco($cdtipoendereco);
        $endereco->setNrcependereco($nrcependereco);
        $endereco->setDscompleendereco($dscompleendereco);
        $endereco->setNrimovelendereco($nrimovelendereco);
        $endereco->setDsendereco($dsendereco);
        $endereco->setDsreferenciaende($dsreferenciaende);
        $endereco->setNrenderecoparc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'ENDERECOPARC', 1, 10, true));
        
        $this->entityManager->persist($endereco);
    }
    
    public function convertDsLogrToCdlogr($dsLogr){
        $retorno = null;
        
        if(is_string($dsLogr)) $dsLogr = strtoupper($dsLogr);
        
        // Mapa dslogradouro=>cdlogradouro.
        $map = array(        
            "RUA" => "RUA",
            "AVENIDA" => "AV",
            "PRAÇA" => "PCA",
            "PRACA" => "PCA",
            "ALAMEDA" => "AL",
            "ESTRADA" => "EST",
            "RODOVIA" => "RDV",
            "QUADRA" => "QD",
            "AEROPORTO" => "AER",
            "APARTAMENTO" => "AP",
            "BECO" => "BC",
            "BLOCO" => "BL",
            "CAMINHO" => "CAM",
            "ESCADINHA" => "ESCD",
            "FAZENDA" => "FAZ",
            "FORTALEZA" => "FORT",
            "GALERIA" => "GL",
            "QUILOMETRO" => "KM",
            "LADEIRA" => "LD",
            "LARGO" => "LGO",
            "PRAIA" => "PR",
            "QUINTA" => "QTA",
            "TRAVESSA" => "TRV",
            "VIADUTO" => "VD",
            "VILA" => "VL",
            "SUPER QUADRA" => "SQD",
            "PARQUE" => "PRQ",
            "CHÁCARA" => "CH",
            "CHACARA" => "CH",
            "CALÇADA" => "CALC",
            "CALCADA" => "CALC",
            "VIA DE ACESSO"=>"V-AC",
            "VIA" => "VIA",
            "SÍTIO" => "SIT",
            "SITIO" => "SIT",
            "ACESSO" => "AC",
            "LOTEAMENTO" => "LOT",
            "PASSAGEM" => "PSG",
            "VIELA" => "VLA",
            "FAVELA" => "FAV",
            "FEIRA" => "FRA",
            "JARDIM" => "JD",
            "LAGO" => "LG",
            "LAGOA" => "LGA",
            "MORRO" => "MRO",
            "TRECHO" => "TR",
            "VALE" => "VLE",
            "VEREDA" => "VER",
            "ACAMPANHAMENTO" => "0003",
            "AREA" => "A",
            "ÁREA" => "A",
            "CAMPO" => "CPO",
            "COLÔNIA" => "COL",
            "COLONIA" => "COL",
            "CONDOMÍNIO" => "CON",
            "CONDOMINIO" => "CON",
            "CONJUNTO" => "CJ",
            "DISTRITO" => "DT",
            "ESPLANADA" => "ESP",
            "NÚCLEO" => "NUC",
            "NUCLEO" => "NUC",
            "OUTROS" => "O",
            "PASSARELA" => "PSA",
            "PÁTIO" => "PAT",
            "PATIO" => "PAT",
            "RECANTO" => "REC",
            "RESIDENCIAL" => "RES",
            "SETOR" => "ROD",
            "ACAMPAMENTO" => "0004",
        );
        
        if(isset($map[$dsLogr]) && !empty($map[$dsLogr])) $retorno = $map[$dsLogr];
        
        return $retorno;

    }
    
    public function importarPlanilhaContaCorrente($row) {
        $nrorg       = $this->hcmParameters->getNrorgTrabalho();
        $nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        $messages    = array(); 
                $dados = $this->getDadosCantaCorrente($row['DSPATH'][0]);
        foreach($dados as $lin => $dado) {
            $res = $this->insereContaCorrente($lin + 2, $nrorg, $nrorgPadrao,
                $dado['NRVINCULOM'], $dado['NMPESSOA'], $dado['CDBANCO'],
                $dado['CDAGENCIA'], $dado['CTCORRENTE'], $dado['TPCONTA']);
            foreach($res as $msg)
                $messages[] = $msg;
        }
        return $messages;
    }
    
    public function getDadosCantaCorrente($path) {
        $head = array(
            'NRVINCULOM',
            'NMPESSOA',
            'CDBANCO',
            'CDAGENCIA',
            'CTCORRENTE',
            'TPCONTA'
            );
        
        $file = $this->httpKernel->factoryFromFileData($path, FPA::getTempDirectory()."/");
        $caminhoNovo = DIRECTORY_SEPARATOR . $file->getPathname();
        
        $file = \PHPExcel_IOFactory::load($caminhoNovo);
        $file->setActiveSheetIndex(0);

        return $this->exportacaoExcelService->preparaInfo_generic($file, $head, 'NRVINCULOM');
    }
    
    public function insereContaCorrente($nrRow, $nrorg, $nrorgPadrao, $nrvinculom, $nmpessoa, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr) {
        $msg = array();
        
        try {
            //Aquisição de dados (nrpessoa e nrparcnegocio) e validações
            $objVinculom = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->findOneBy(
                array('nrorg' => $nrorg, 'nrvinculom' => $nrvinculom));
            if($objVinculom == null) {
                $msg[] = array("msg" => "Vínculo '$nrvinculom' não encontrado na linha $nrRow.");
            } else {
                $objPessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(
                    array('nrorg' => $nrorg, 'nrpessoa' => $objVinculom->getNrpessoa()));
                if($objPessoa == null) {
                    $msg[] = array("msg" => "A pessoa do vínculo '$nrvinculom' não foi encontrada. Linha $nrRow.");
                } else {
                    $nrparcnegocio = $objPessoa->getNrparcnegocio();
                }
            }
            //Banco
            if(!is_numeric($cdbanco))
                $msg[] = array("msg" => "Código do banco ($cdbanco) deve ser numérico. Linha $nrRow.");
            else {
                $cdbanco = str_pad($cdbanco, 3, '0', STR_PAD_LEFT);
                $objBanco = $this->entityManager->getRepository(Repositories::BANCO)->findOneBy(
                    array('cdbanco' => $cdbanco));
                if($objBanco == null)
                    $msg[] = array("msg" => "Código do banco ($cdbanco) inválido na linha $nrRow.");
            }
            //Agência
            if(!is_numeric($cdagencia))
                $msg[] = array("msg" => "Código da agência ($cdagencia) deve ser numérico. Linha $nrRow.");
            //Conta corrente
            if($cdcontcorr == null)
                $msg[] = array("msg" => "O número da conta deve ser informado. Linha $nrRow.");
            else if(!is_numeric($cdcontcorr))
                $msg[] = array("msg" => "O número da conta ($cdcontcorr) deve ter somente números. Linha $nrRow.");
            if(strlen($cdcontcorr) > 20)
                $msg[] = array("msg" => "O número da conta ($cdcontcorr) deve ter no máxmo 20 caracteres. Linha $nrRow.");
            //Tipo de conta
            if($nrtpcontcorr == null) //Valor default
                $nrtpcontcorr = '2';
            if(!in_array($nrtpcontcorr, array("1", "2", "3", "4")))
                $msg[] = array("msg" => "Tipo de conta ($nrtpcontcorr) inválido na linha $nrRow. Permitido: 1 C. Moviment.; 2 CNAB; 3 C. Salário; 4 Pensão Judicial.");
            
            //Verificação de registro ká existente e Inserção
            if(count($msg) == 0) { //Apenas se não houver erros
                $objContcorrparc = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(
                    array('nrorg' => $nrorg, 'nrparcnegocio' => $nrparcnegocio, 'cdbanco' => $cdbanco, 'idativo' => 'S'));
                if($objContcorrparc == null) {
                    $this->novoContaCorrente($nrparcnegocio, null, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr);
                    $this->entityManager->flush();
                } else
                    $msg[] = array("msg" => "O vínculo $nrvinculom já possui uma conta bancária no banco $cdbanco. Registro não inserido. Linha $nrRow.");
            }
        } catch (\Exception $e) {
            throw $e;
        }
        return $msg;
    }
    
    public function novoContaCorrente($nrparcnegocio, $cdreducont, $cdbanco,
                     $cdagencia, $cdcontcorr, $nrtpcontcorr)
    {
        $contaCorr = new $this->contCorrParc;
        $contaCorr->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setDtinclusao(DateUtil::getDataAtual());
        $contaCorr->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $contaCorr->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setDtultatu(DateUtil::getDataAtual());
        $contaCorr->setCdoperultatu($this->hcmParameters->getCdoperador());
        $contaCorr->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setIdativo('S');
        $contaCorr->setNrparcnegocio($nrparcnegocio);
        $contaCorr->setCdreducont($cdreducont);
        $contaCorr->setCdbanco($cdbanco);
        $contaCorr->setCdagencia($cdagencia);
        $contaCorr->setCdcontcorr($cdcontcorr);
        $contaCorr->setNrtpcontcorr($nrtpcontcorr);
        $contaCorr->setNrcontcorrparc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'CONTCORRPARC', 1, 10, true));
        $this->entityManager->persist($contaCorr);
    }
    
    public function defineBairro($endereco) {
        if ($endereco->getCdbairro() !== null) {
            $bairro = $this->entityManager->getRepository(Repositories::BAIRRO)->findBy(array('cdpais' => $endereco->getCdpais(),
            'sgestado' => $endereco->getSgestado(),'cdmunicipio'=> $endereco->getCdmunicipio(),'cdbairro'=> $endereco->getCdbairro()));
            return $bairro->getNmbairro();
        } else {
            return $endereco->getNmbairroendereco();
        }
    }
    
    /*Planilhas*/
    /*Forma de comunicação*/
    public function baixarPlanilhaFormaComunicacao($nrorg, $nmarquivo) {
        $cabecalho = array(
            "Nr. Vínculo",
            "Nome",
            "Prefixo",
            "Telefone Principal",
            "Prefixo",
            "Celular Particular",
            "Email",
            "Prefixo",
            "Telefone Residencial",
            "Prefixo",
            "Telefone Comercial",
            "Prefixo",
            "Celular Comercial"
        );
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        
        $vinculos = $this->getListaVinculos($nrorg, $dtmescompetenc);
        if(count($vinculos) == 0) {
            $vinculos[0][] = "9999";
            $vinculos[0][] = "Nome do vínculo";
        }
        $vinculos[0][] = "31";
        $vinculos[0][] = "912345678";
        $vinculos[0][] = "31";
        $vinculos[0][] = "998765432";
        $vinculos[0][] = "nomedeemail@servidor.com";
        $vinculos[0][] = "31";
        $vinculos[0][] = "21211234";
        $vinculos[0][] = "";
        $vinculos[0][] = "";
        $vinculos[0][] = "31";
        $vinculos[0][] = "21215678";
        
        return $this->exportacaoExcelService->gravarTemplate_1($nrorg, $cabecalho, $nmarquivo, $vinculos);
    }
    
    public function getListaVinculos($nrorg, $dtmesompetenc) {
        $res = $this->vinculoServices->retornaVinculosCompetencia($nrorg, $dtmesompetenc, false, null, null, 'ALFABETICA');

        $return = array();
        
        foreach($res as $key => $val) {
            $return[$key][] = $val['NRVINCULOM'];
            $return[$key][] = $val['NMVINCULOM'];
        }
        
        return $return;
    }
    
    public function getDadosComunicaparc($path) {
        $head = array(
            'NRVINCULOM',
            'NMVINCULOM',
            'CDPREFIXCOMUPARC_01',
            'CDCOMUNICAPARC_01',
            'CDPREFIXCOMUPARC_02',
            'CDCOMUNICAPARC_02',
            'CDCOMUNICAPARC_05',
            'CDPREFIXCOMUPARC_03',
            'CDCOMUNICAPARC_03',
            'CDPREFIXCOMUPARC_04',
            'CDCOMUNICAPARC_04',
            'CDPREFIXCOMUPARC_06',
            'CDCOMUNICAPARC_06'
            );
        
        $file = $this->httpKernel->factoryFromFileData($path, FPA::getTempDirectory()."/");
        $caminhoNovo = DIRECTORY_SEPARATOR . $file->getPathname();
        
        $file = \PHPExcel_IOFactory::load($caminhoNovo);
        $file->setActiveSheetIndex(0);

        return $this->exportacaoExcelService->preparaInfo_generic($file, $head, 'NRVINCULOM');
    }
    
    public function importarPlanilhaFormaComunicacao($row) {
        $nrorg       = $this->hcmParameters->getNrorgTrabalho();
        $nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        $messages    = array(); 
        $dados       = $this->getDadosComunicaparc($row['DSPATH'][0]);

        foreach($dados as $lin => $dado) {
            $res = $this->insereFormaComunicacao($lin + 2, $nrorg, $nrorgPadrao,
                $dado['NRVINCULOM'],
                $dado['NMVINCULOM'],
                $dado['CDPREFIXCOMUPARC_01'],
                $dado['CDCOMUNICAPARC_01'],
                $dado['CDPREFIXCOMUPARC_02'],
                $dado['CDCOMUNICAPARC_02'],
                $dado['CDCOMUNICAPARC_05'],
                $dado['CDPREFIXCOMUPARC_03'],
                $dado['CDCOMUNICAPARC_03'],
                $dado['CDPREFIXCOMUPARC_04'],
                $dado['CDCOMUNICAPARC_04'],
                $dado['CDPREFIXCOMUPARC_06'],
                $dado['CDCOMUNICAPARC_06'] );
            foreach($res as $msg)
                $messages[] = $msg;
        }
        return $messages;
    }
    
    public function insereFormaComunicacao($nrRow, $nrorg, $nrorgPadrao, $nrvinculom, $nmvinculom,
        $cdprefixcomuparc_01, $cdcomunicaparc_01,
        $cdprefixcomuparc_02, $cdcomunicaparc_02,
        $cdcomunicaparc_05,
        $cdprefixcomuparc_03, $cdcomunicaparc_03,
        $cdprefixcomuparc_04, $cdcomunicaparc_04,
        $cdprefixcomuparc_06, $cdcomunicaparc_06) {
        $msg           = array();
        $exist         = array('01' => false, '02' => false, '03' => false, '04' => false, '05' => false, '06' => false); //Marca as formas de comunicação já existentes para o vícnulo em questão
        $nrparcnegocio = null; //sinaliza que não há um vínculo válido
        
        try {
            //Aquisição de dados (nrpessoa e nrparcnegocio) e validações
            $objVinculom = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->findOneBy(
                array('nrorg' => $nrorg, 'nrvinculom' => $nrvinculom));
            if($objVinculom == null) {
                $msg[] = array("msg" => "Vínculo '$nrvinculom' não encontrado.", "row" => $nrRow);
            } else {
                $objPessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(
                    array('nrorg' => $nrorg, 'nrpessoa' => $objVinculom->getNrpessoa()));
                if($objPessoa == null) {
                    $msg[] = array("msg" => "A pessoa do vínculo '$nrvinculom' não foi encontrada.", "row" => $nrRow);
                } else {
                    $nrparcnegocio = $objPessoa->getNrparcnegocio();
                }
            }
            
            //Trunca para o máximo do campo na tabela
            $cdcomunicaparc_01 = substr($cdcomunicaparc_01, 0, 250);
            $cdcomunicaparc_02 = substr($cdcomunicaparc_02, 0, 250);
            $cdcomunicaparc_05 = substr($cdcomunicaparc_05, 0, 250);
            $cdcomunicaparc_03 = substr($cdcomunicaparc_03, 0, 250);
            $cdcomunicaparc_04 = substr($cdcomunicaparc_04, 0, 250);
            $cdcomunicaparc_06 = substr($cdcomunicaparc_06, 0, 250);
            
            //Eliminando prefixo orfão
            if($cdprefixcomuparc_01 != null && $cdcomunicaparc_01 == null) $cdprefixcomuparc_01 = null; 
            if($cdprefixcomuparc_02 != null && $cdcomunicaparc_02 == null) $cdprefixcomuparc_02 = null;
            if($cdprefixcomuparc_03 != null && $cdcomunicaparc_03 == null) $cdprefixcomuparc_03 = null;
            if($cdprefixcomuparc_04 != null && $cdcomunicaparc_04 == null) $cdprefixcomuparc_04 = null;
            if($cdprefixcomuparc_06 != null && $cdcomunicaparc_06 == null) $cdprefixcomuparc_06 = null;
            
            //Verifica se existe pelo menos alguma forma de comunicação
            if(!($cdcomunicaparc_01 || $cdcomunicaparc_02 || $cdcomunicaparc_03 || $cdcomunicaparc_04 || $cdcomunicaparc_05 || $cdcomunicaparc_06))
                $msg[] = array("msg" => "Pelo menos uma forma de comunicação deve ser inserida.", "row" => $nrRow);

            //01 Telefone principal
            if($cdcomunicaparc_01   && !is_numeric($cdcomunicaparc_01))   { $msg[] = array("msg" => "O número do telefone principal ($cdcomunicaparc_01) deve ser numérico.", "row" => $nrRow);                  $cdcomunicaparc_01 = null; }
            if($cdprefixcomuparc_01 && !is_numeric($cdprefixcomuparc_01)) { $msg[] = array("msg" => "O prefixo do telefone principal ($cdprefixcomuparc_01) deve ser numérico.", "row" => $nrRow);               $cdcomunicaparc_01 = null; }
            if(strlen($cdprefixcomuparc_01) > 10)                         { $msg[] = array("msg" => "O prefixo do telefone principal ($cdprefixcomuparc_01) deve ter no máximo 10 dígitos.", "row" => $nrRow);   $cdcomunicaparc_01 = null; }
            
            //02 Celular particular
            if($cdprefixcomuparc_02 && !is_numeric($cdprefixcomuparc_02)) { $msg[] = array("msg" => "O prefixo do celular particular ($cdprefixcomuparc_02) deve ser numérico.", "row" => $nrRow);               $cdcomunicaparc_02 = null; }
            if($cdcomunicaparc_02   && !is_numeric($cdcomunicaparc_02))   { $msg[] = array("msg" => "O número do celular particular ($cdcomunicaparc_02) deve ser numérico.", "row" => $nrRow);                  $cdcomunicaparc_02 = null; }
            if(strlen($cdprefixcomuparc_02) > 10)                         { $msg[] = array("msg" => "O prefixo do celular particular ($cdprefixcomuparc_02) deve ter no máximo 10 dígitos.", "row" => $nrRow);   $cdcomunicaparc_02 = null; }
            
            //05 email
            if($cdcomunicaparc_05   && !filter_var($cdcomunicaparc_05, FILTER_VALIDATE_EMAIL)) { $msg[] = array("msg" => "E-mail inválido ($cdcomunicaparc_05).", "row" => $nrRow);                              $cdcomunicaparc_05 = null; }
            
            //03 Telefone residencial
            if($cdprefixcomuparc_03 && !is_numeric($cdprefixcomuparc_03)) { $msg[] = array("msg" => "O prefixo do telefone residencial ($cdprefixcomuparc_03) deve ser numérico.", "row" => $nrRow);             $cdcomunicaparc_03 = null; }
            if($cdcomunicaparc_03   && !is_numeric($cdcomunicaparc_03))   { $msg[] = array("msg" => "O número do telefone residencial ($cdcomunicaparc_03) deve ser numérico.", "row" => $nrRow);                $cdcomunicaparc_03 = null; }
            if(strlen($cdprefixcomuparc_03) > 10)                         { $msg[] = array("msg" => "O prefixo do telefone residencial ($cdprefixcomuparc_03) deve ter no máximo 10 dígitos.", "row" => $nrRow); $cdcomunicaparc_03 = null; }
            
            //04 Telefone comercial
            if($cdprefixcomuparc_04 && !is_numeric($cdprefixcomuparc_04)) { $msg[] = array("msg" => "O prefixo do telefone comercial ($cdprefixcomuparc_04) deve ser numérico.", "row" => $nrRow);               $cdcomunicaparc_04 = null; }
            if($cdcomunicaparc_04   && !is_numeric($cdcomunicaparc_04))   { $msg[] = array("msg" => "O número do telefone comercial ($cdcomunicaparc_04) deve ser numérico.", "row" => $nrRow);                  $cdcomunicaparc_04 = null; }
            if(strlen($cdprefixcomuparc_04) > 10)                         { $msg[] = array("msg" => "O prefixo do telefone comercial ($cdprefixcomuparc_04) deve ter no máximo 10 dígitos.", "row" => $nrRow);   $cdcomunicaparc_04 = null; }
            
            //06 Celular comercial
            if($cdprefixcomuparc_06 && !is_numeric($cdprefixcomuparc_06)) { $msg[] = array("msg" => "O prefixo do celular comercial ($cdprefixcomuparc_06) deve ser numérico.", "row" => $nrRow);                $cdcomunicaparc_06 = null; }
            if($cdcomunicaparc_06   && !is_numeric($cdcomunicaparc_06)  ) { $msg[] = array("msg" => "O número do celular comercial ($cdcomunicaparc_06) deve ser numérico.", "row" => $nrRow);                   $cdcomunicaparc_06 = null; }
            if(strlen($cdprefixcomuparc_06) > 10)                         { $msg[] = array("msg" => "O prefixo do celular comercial ($cdprefixcomuparc_06) deve ter no máximo 10 dígitos.", "row" => $nrRow);    $cdcomunicaparc_06 = null; }

            //Verificação de registro já existente e Inserção
            if($nrparcnegocio != null) { //Apenas se houver um vínculo válido
                
                //Busca formas de comunicação do vínculo para não inserir repetido
                $objComunicaparc = $this->entityManager->getRepository(Repositories::COMUNICAPARC)->findBy(
                    array('nrorg' => $nrorg, 'nrparcnegocio' => $nrparcnegocio, 'idativo' => 'S', 'cdformacomu' => array('01', '02', '05', '03', '04', '06')));
                foreach($objComunicaparc as $row)
                    $exist[$row->getCdformacomu()] = true;
                
                //01 Telefone principal
                if($cdcomunicaparc_01)
                    if($exist['01']) $msg[] = array("msg" => "Já existe um telefone principal cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '01', $cdprefixcomuparc_01, $cdcomunicaparc_01, null, null);
                
                //02 Celular particular
                if($cdcomunicaparc_02)
                    if($exist['02']) $msg[] = array("msg" => "Já existe um celular particular cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '02', $cdprefixcomuparc_02, $cdcomunicaparc_02, null, null);
                
                //05 email
                if($cdcomunicaparc_05)
                    if($exist['05']) $msg[] = array("msg" => "Já existe um e-mail cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '05', null, $cdcomunicaparc_05, null, null);
                
                //03 Telefone residencial
                if($cdcomunicaparc_03)
                    if($exist['03']) $msg[] = array("msg" => "Já existe um telefone residencial cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '03', $cdprefixcomuparc_03, $cdcomunicaparc_03, null, null);
                
                //04 Telefone comercial
                if($cdcomunicaparc_04)
                    if($exist['04']) $msg[] = array("msg" => "Já existe um telefone comercial cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '04', $cdprefixcomuparc_04, $cdcomunicaparc_04, null, null);
                
                //06 Celular comercial
                if($cdcomunicaparc_06)
                    if($exist['06']) $msg[] = array("msg" => "Já existe um celular comercial cadastrado e ativo para o vínculo $nrvinculom. Registro não inserido.", "row" => $nrRow);
                    else             $this->novaFormacomu($nrparcnegocio, '06', $cdprefixcomuparc_06, $cdcomunicaparc_06, null, null);
            }
        } catch (\Exception $e) {
            throw $e;
        }
        return $msg;
    }
}