-- ============================================================
-- Database name: FOLHA
-- Created on: 02/04/2020 
-- ============================================================
-- ============================================================
-- TABLE: LANCAMENTOSVINC_TMP
-- ============================================================
TRUNCATE TABLE LANCAMENTOSVINC_TMP;
DROP TABLE LANCAMENTOSVINC_TMP;

CREATE GLOBAL TEMPORARY TABLE LANCAMENTOSVINC_TMP
 (NRORG             NUMBER,
  NRVINCULOM        NUMBER,
  NRPESSOA          NUMBER,
  DTADMISSAOVINC    DATE,
  DTRESCISAOVINC    DATE,
  NRTIPOVINCULOM    NUMBER,
  NRVINCULOEMPREG   NUMBER,
  NMVINCULOM        VARCHAR(100),
  DTMESCOMPETENC    DATE,
  NRESTRUTLEGAL     NUMBER,
  NRESTRUTGEREN     NUMBER,
  NRESTRUTSIND      NUMBER,
  NRCALCULOFOLHA    NUMBER,
  NRTIPOMOVIMENT    NUMBER,
  NRTPMODALIDCAL    NUMBER,
  NROCORRECAL       NUMBER,
  DTOCORRENCIACALC  DATE,
  NRITEMCALCFOLHA   NUMBER,
  NREVENTOM         NUMBER,
  VRREFFOLHA        FLOAT,
  VREVENTOFOLHA     FLOAT,
  IDREFEVALORCALC   VARCHAR2(50),
  DTOCORRENCIA      DATE) ON COMMIT PRESERVE ROWS
/

CREATE TABLE LANCAMENTOSVINC_DIRF
(
  NRORG             NUMBER,
  NRVINCULOM        NUMBER,
  NRPESSOA          NUMBER,
  DTADMISSAOVINC    DATE,
  DTRESCISAOVINC    DATE,
  NRTIPOVINCULOM    NUMBER,
  NRVINCULOEMPREG   NUMBER,
  NMVINCULOM        VARCHAR(100),
  DTMESCOMPETENC    DATE,
  NRESTRUTLEGAL     NUMBER,
  NRESTRUTGEREN     NUMBER,
  NRESTRUTSIND      NUMBER,
  NRCALCULOFOLHA    NUMBER,
  NRTIPOMOVIMENT    NUMBER,
  NRTPMODALIDCAL    NUMBER,
  NROCORRECAL       NUMBER,
  DTOCORRENCIACALC  DATE,
  NRITEMCALCFOLHA   NUMBER,
  NREVENTOM         NUMBER,
  VRREFFOLHA        FLOAT,
  VREVENTOFOLHA     FLOAT,
  IDREFEVALORCALC   VARCHAR2(50),
  DTOCORRENCIA      DATE
);

INSERT INTO LANCAMENTOSVINC_DIRF
SELECT
  VM.NRORG,
  VM.NRVINCULOM,
  PE.NRPESSOA,
  VM.DTADMISSAOVINC,
  VM.DTRESCISAOVINC,
  VM.NRTIPOVINCULOM,
  VM.NRVINCULOEMPREG,
  VM.NMVINCULOM,
  PH.NMPESSOA,
  PH.NRCPFPESSOA,
  VH.DTMESCOMPETENC,
  VH.NRESTRUTLEGAL,
  VH.NRESTRUTGEREN,
  VH.NRESTRUTSIND,
  CF.NRCALCULOFOLHA,
  CF.NRTIPOMOVIMENT,
  CF.NRTPMODALIDCAL,
  CF.NROCORRECAL,
  CF.DTOCORRENCIA AS DTOCORRENCIACALC,
  ICF.NRITEMCALCFOLHA,
  ICF.NREVENTOM,
  ICF.VRREFFOLHA,
  ICF.VREVENTOFOLHA,
  ICF.IDREFEVALORCALC,
  ICF.DTOCORRENCIA
FROM FPA_CALCULOFOLHA CF 
JOIN DATA DT ON DT.DTDATA = CF.DTOCORRENCIA
JOIN FPA_ITECALCFOLHA ICF ON ICF.NRORG = CF.NRORG
                         AND ICF.NRCALCULOFOLHA = CF.NRCALCULOFOLHA
JOIN GPE_VINCULOM VM ON VM.NRORG = ICF.NRORG
                    AND VM.NRVINCULOM = ICF.NRVINCULOM
                    AND ( VM.DTRESCISAOVINC IS NULL
                          OR ( VM.DTRESCISAOVINC >= TRUNC( TO_DATE( :dtcompetencia ), 'YEAR' ) ) )
JOIN GPE_VINCULOH VH ON VH.NRORG = VM.NRORG
                    AND VH.NRVINCULOM = VM.NRVINCULOM
                    AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM (SELECT H1.DTMESCOMPETENC FROM GPE_VINCULOH H1
                                                                               WHERE H1.NRORG      = VH.NRORG
                                                                                 AND H1.NRVINCULOM = VH.NRVINCULOM
                                                                                 AND H1.DTMESCOMPETENC <= DT.DTDATA ORDER BY H1.DTMESCOMPETENC DESC) WHERE ROWNUM = 1)
/*Código da receita do vínculo em questão (item 3.5)*/
LEFT JOIN GPE_VINCULOEMPREG VE ON VE.NRVINCULOEMPREG = VM.NRVINCULOEMPREG
/*CPF e Nome do vínculo em questão (item 3.6)*/
JOIN GPE_PESSOA  PE ON PE.NRORG    = VM.NRORG
                   AND PE.NRPESSOA = VM.NRPESSOA
JOIN GPE_PESSOAH PH ON PH.NRORG    = PE.NRORG
                   AND PH.NRPESSOA = PE.NRPESSOA
                   AND PH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_PESSOAH
                                             WHERE DTMESCOMPETENC <= :dtcompetencia
                                               AND NRORG    = PH.NRORG
                                               AND NRPESSOA = PH.NRPESSOA )
WHERE CF.NRORG = :nrorg
 /*2 6*/ AND CF.DTOCORRENCIA BETWEEN DECODE(CF.NRTIPOMOVIMENT, 2, ADD_MONTHS(TRUNC(TO_DATE('01/12/2020'),'YEAR'), -1),
                                                                             10, ADD_MONTHS(TRUNC(TO_DATE('01/12/2020'),'YEAR'), -1),
                                                                             1, ADD_MONTHS(TRUNC(TO_DATE('01/12/2020'),'YEAR'), -1),
                                                                             4, TO_DATE('01/12/2020'),
                                                                             TRUNC(TO_DATE('01/12/2020'),'YEAR'))
                                             --AND DECODE(CF.NRTIPOMOVIMENT, 1, ADD_MONTHS('01/12/2020', -1), '01/12/2020')
                                             AND DECODE(CF.NRTIPOMOVIMENT, 1, DECODE(TO_CHAR(VM.DTRESCISAOVINC, 'MMYYYY'), TO_CHAR(CF.DTOCORRENCIA,'MMYYYY'), '01/12/2020', ADD_MONTHS('01/12/2020', -1)), '01/12/2020')
  AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT, 10, DECODE(ICF.NREVENTOM, 475, 475, DECODE(CF.DTOCORRENCIA, TO_DATE(:dtcompetencia /*:P_COMPETENCIA*/), 1390, 0)), ICF.NREVENTOM)
  AND ICF.NREVENTOM = DECODE(CF.NRTIPOMOVIMENT,  1, DECODE(ICF.NREVENTOM, 205239, 0, 205543, 0, ICF.NREVENTOM), ICF.NREVENTOM) /*Apenas devem vir no movimento 4 (13º sal)*/
  AND (VH.NRESTRUTLEGAL = :inicio AND VH.NRESTRUTGEREN  = NVL('', VH.NRESTRUTGEREN))
  AND EXISTS ( SELECT 1
                 FROM FPA_ITECALCFOLHA
                WHERE NRORG = ICF.NRORG
                  AND NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
                  AND NRVINCULOM = ICF.NRVINCULOM
                  AND NREVENTOM IN (SELECT NREVENTOM FROM FPA_INCIDEVENTO WHERE (NRORG = ICF.NRORG OR NRORG = 0) AND NRTIPOINCIDE = 109)
                  AND VREVENTOFOLHA > 0 );

CREATE INDEX LANCAMENTOSVINC_DIRF_01 ON LANCAMENTOSVINC_DIRF (NRORG, NRESTRUTLEGAL, NRESTRUTGEREN);