<?php
namespace Planejamento\Entities;

use Setforms2\Shared\ORM\DateTime;

class Grupnutr extends Base\Grupnutr
{
    /**
     * Cria um novo registro, mas nao o insere no banco imediatamente.
     *
     * @param String   $nrorg      Organização
     * @param DateTime $data       Data
     * @param String   $oper       Operador
     * @param String   $cdgrupnutr Código
     * @param String   $nmgrupnutr Nome
     * @param self     $grupnutr   Grupo de Nutrientes
     *
     * @return null
     */
    public static function criaGrupnutr(
        $nrorg, $data, $oper, $cdgrupnutr, $nmgrupnutr, $grupnutr = null
    ) {
        if (($grupnutr == null) || ($grupnutr === false)) {
            $grupnutr = new Grupnutr();
        } else {
            if (!$grupnutr instanceof self) {
                return null;
            }
        }

        $grupnutr->setNrorg($nrorg);
        $grupnutr->setNrorginclusao($nrorg);
        $grupnutr->setNrorgultatu($nrorg);

        $grupnutr->setDtultatugrnu($data);
        $grupnutr->setDtinclusao($data);
        $grupnutr->setDtultatu($data);

        $grupnutr->setCdoperinclusao($oper);
        $grupnutr->setCdoperultatu($oper);

        $grupnutr->setCdgrupnutr($cdgrupnutr);
        $grupnutr->setNmgrupnutr($nmgrupnutr);

        $grupnutr->persist();
    }
}